package com.sample;


import java.net.MalformedURLException;
import java.net.URL;
import java.security.cert.Certificate;
import java.io.*;

import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLPeerUnverifiedException;

public class POJOHttpClient{
 
   public static void main(String[] args)
   {
        new POJOHttpClient().testIt();
   }
 
   private void testIt(){
	   
	   
       String name = "rick";
       String password = "password";
       String authString = name + ":" + password;
       System.out.println("auth string: " + authString);
       String authEncBytes = com.sun.org.apache.xerces.internal.impl.dv.util.Base64.encode(authString.getBytes());
       String authStringEnc = new String(authEncBytes);
       System.out.println("Base64 encoded auth string: " + authStringEnc);

       String https_url = "https://localhost:18443/SimpleServlet2/SimpleServlet?authMethod=Basic&authUsername=rick&authPassword=password&arg1=value1";
      URL url;
      try {
 
	     url = new URL(https_url);	     
	     HttpsURLConnection con = (HttpsURLConnection)url.openConnection();
	     con.setRequestMethod("GET");
	     con.setRequestProperty("Authorization", "Basic " + authStringEnc);
	     con.setRequestProperty("SomeProperty", "SomeValue");
	     
 
	     //dumpl all cert info
	     print_https_cert(con);
 
	     //dump all the content
	     print_content(con);
 
      } catch (MalformedURLException e) {
	     e.printStackTrace();
      } catch (IOException e) {
	     e.printStackTrace();
      }
 
   }
 
   private void print_https_cert(HttpsURLConnection con){
 
    if(con!=null){
 
      try {
 
	System.out.println("Response Code : " + con.getResponseCode());
	System.out.println("Cipher Suite : " + con.getCipherSuite());
	System.out.println("\n");
 
	Certificate[] certs = con.getServerCertificates();
	for(Certificate cert : certs){
	   System.out.println("Cert Type : " + cert.getType());
	   System.out.println("Cert Hash Code : " + cert.hashCode());
	   System.out.println("Cert Public Key Algorithm : " 
                                    + cert.getPublicKey().getAlgorithm());
	   System.out.println("Cert Public Key Format : " 
                                    + cert.getPublicKey().getFormat());
	   System.out.println("\n");
	}
 
	} catch (SSLPeerUnverifiedException e) {
		e.printStackTrace();
	} catch (IOException e){
		e.printStackTrace();
	}
 
     }
 
   }
 
   private void print_content(HttpsURLConnection con){
	if(con!=null){
 
	try {
 
	   System.out.println("****** Content of the URL ********");			
	   BufferedReader br = 
		new BufferedReader(
			new InputStreamReader(con.getInputStream()));
 
	   String input;
 
	   while ((input = br.readLine()) != null){
	      System.out.println(input);
	   }
	   br.close();
 
	} catch (IOException e) {
	   e.printStackTrace();
	}
 
       }
 
   }
 
}